



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>opencv学习系列：连通域参考处理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">opencv学习系列：连通域参考处理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:38:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">OpenCV里提取目标轮廓的函数是findContours，它的输入图像是一幅二值图像，输出的是每一个连通区域的轮廓点的集合：vector&lt;vector&lt;Point&gt;&gt;。<br />
外层vector的size代表了图像中轮廓的个数，里面vector的size代表了轮廓上点的个数。

hiararchy参数和轮廓个数相同，每个轮廓contours[ i ]对应4个hierarchy元素hierarchy[ i ][ 0 ] ~hierarchy[ i ][ 3 ]，分别表示后一个轮廓、前一个轮廓、父轮廓、内嵌轮廓的索引编号，如果没有对应项，该值设置为负数。<br />
第六个参数传入CV_CHAIN_CODE时，要设置成sizeof(CvChain),其它情况统一设置成sizeof(CvContour)<br />
CV_CHAIN_CODE：以Freeman链码的方式输出轮廓，所有其他方法输出多边形（顶点的序列）。<br />
CV_CHAIN_APPROX_SIMPLE：压缩水平的、垂直的和斜的部分，也就是，函数只保留他们的终点部分。例如一个矩形轮廓只需4个点来保存轮廓信息<br />
CV_RETR_EXTERNAL：只检索最外面的轮廓；<br />
CV_RETR_LIST：检测的轮廓不建立等级关系，检索所有的轮廓，并将其保存到一条链表当中；<br />
CV_RETR_CCOMP：建立两个等级的轮廓，上面的一层为外边界，里面的一层为内孔的边界信息。检索所有的轮廓，并将他们组织为两层：顶层是各部分的外部边界，第二层是空洞的边界；<br />
CV_RETR_TREE：检索所有的轮廓，并重构嵌套轮廓的整个层次，可以参见下图。<br />
加滚动条确定阈值化的合适阈值！：http://blog.csdn.net/augusdi/article/details/9021467<br />
****************************************************************************************<br />
//做一下膨胀，x与y方向都做，但系数不同<br />
            var kernal = Cv.CreateStructuringElementEx(5, 2, 1, 1, ElementShape.Rect);<br />
            Cv.Erode(gray, gray, kernal, 2);

            //二值化<br />
            Cv.Threshold(gray, gray, 0, 255, ThresholdType.BinaryInv | ThresholdType.Otsu);

            //检测连通域，每一个连通域以一系列的点表示，FindContours方法只能得到第一个域<br />
            var storage = Cv.CreateMemStorage();<br />
            CvSeq&lt;CvPoint&gt; contour = null;<br />
            Cv.FindContours(gray, storage, out contour, CvContour.SizeOf, ContourRetrieval.CComp, ContourChain.ApproxSimple);<br />
            var color = new CvScalar(0, 0, 255);

            //开始遍历<br />
            while (contour != null)<br />
            {<br />
                //得到这个连通区域的外接矩形<br />
                var rect = Cv.BoundingRect(contour);

                //如果高度不足，或者长宽比太小，认为是无效数据，否则把矩形画到原图上<br />
                if(rect.Height &gt; 10 &amp;&amp; (rect.Width * 1.0 / rect.Height) &gt; 0.2)<br />
                    Cv.DrawRect(src, rect, color);

                //取下一个连通域<br />
                contour = contour.HNext;<br />
            }

***************************************************************

***********************************************************************************************************<br />
// 移除过小或过大的轮廓<br />
void getSizeContours(vector&lt;vector&lt;Point&gt;&gt; &amp;contours)<br />
{<br />
    int cmin = 100;   // 最小轮廓长度<br />
    int cmax = 1000;   // 最大轮廓长度<br />
    vector&lt;vector&lt;Point&gt;&gt;::const_iterator itc = contours.begin();<br />
    while(itc != contours.end())<br />
    {<br />
        if((itc-&gt;size()) &lt; cmin || (itc-&gt;size()) &gt; cmax)<br />
        {<br />
            itc = contours.erase(itc);<br />
        }<br />
        else ++ itc;<br />
    }<br />
}<br />
****************************************************************************<br />
while(contour) {<br />
  /*area = cvContourArea(contour, CV_WHOLE_SEQ);*/<br />
  area = fabs(cvContourArea( contour, CV_WHOLE_SEQ )); //获取当前轮廓面积<br />
  printf("area == %lf\n", area);<br />
  //画轮廓<br />
  //画外接矩形<br />
  CvRect r = ((CvContour*)contour)-&gt;rect;<br />
  if (r.height * r.width &gt; size)<br />
  {<br />
   cvRectangle(pimg, cvPoint(r.x, r.y), cvPoint(r.x + r.width, r.y + r.height),CV_RGB(255, 0, 0), 1, CV_AA, 0);

  }<br />
  contour = contour-&gt;h_next;

 }

*********************************************************************************************************<br />
// Get the contours of the connected components<br />
    std::vector&lt;std::vector&lt;cv::Point&gt;&gt; contours;  

    cv::findContours(gray,<br />
        contours, // a vector of contours<br />
        CV_RETR_EXTERNAL , // retrieve the external contours<br />
        CV_CHAIN_APPROX_NONE); // retrieve all pixels of each contours  

    // Print contours' length<br />
    std::cout &lt;&lt; "Contours: " &lt;&lt; contours.size() &lt;&lt; std::endl;<br />
    std::vector&lt;std::vector&lt;cv::Point&gt;&gt;::const_iterator itContours= contours.begin();<br />
    for ( ; itContours!=contours.end(); ++itContours)<br />
    {  

        std::cout &lt;&lt; "Size: " &lt;&lt; itContours-&gt;size() &lt;&lt; std::endl;<br />
    }  

    // draw black contours on white image<br />
    cv::Mat result(image.size(),CV_8U,cv::Scalar(255));<br />
    cv::drawContours(result,contours,<br />
        -1, // draw all contours<br />
        cv::Scalar(0), // in black<br />
        2); // with a thickness of 2  

************************************************************************<br />
 double maxarea = 0;<br />
    double minarea = 100;<br />
    int m = 0;<br />
    for( ; contour != 0; contour = contour-&gt;h_next )<br />
    {    

        double tmparea = fabs(cvContourArea(contour));<br />
        if(tmparea &lt; minarea)<br />
        {<br />
            cvSeqRemove(contour, 0); // 删除面积小于设定值的轮廓<br />
            continue;<br />
        }<br />
        CvRect aRect = cvBoundingRect( contour, 0 );<br />
        if ((aRect.width/aRect.height)&lt;1)<br />
        {<br />
            cvSeqRemove(contour, 0); //删除宽高比例小于设定值的轮廓<br />
            continue;<br />
        }<br />
        if(tmparea &gt; maxarea)<br />
        {<br />
            maxarea = tmparea;<br />
        }<br />
        m++;<br />
        // 创建一个色彩值<br />
        CvScalar color = CV_RGB( 0, 255, 255 );  

        //max_level 绘制轮廓的最大等级。如果等级为0，绘制单独的轮廓。如果为1，绘制轮廓及在其后的相同的级别下轮廓<br />
        //如果值为2，所有的轮廓。如果等级为2，绘制所有同级轮廓及所有低一级轮廓，诸此种种<br />
        //如果值为负数，函数不绘制同级轮廓，但会升序绘制直到级别为abs(max_level)-1的子轮廓<br />
        cvDrawContours(dst, contour, color, color, -1, 1, 8);   //绘制外部和内部的轮廓<br />
    }<br />
    contour = _contour;<br />
    int count = 0;<br />
    for(; contour != 0; contour = contour-&gt;h_next)<br />
    {<br />
        count++;<br />
        double tmparea = fabs(cvContourArea(contour));<br />
        if (tmparea == maxarea)<br />
        {<br />
            CvScalar color = CV_RGB( 255, 0, 0);<br />
            cvDrawContours(dst, contour, color, color, -1, 1, 8);<br />
        }<br />
    }<br />
*************************************************************************************<br />
在提取之前还可以调用一个函数：<br />
         contour = cvApproxPoly( contour, sizeof(CvContour), storage, CV_POLY_APPROX_DP, 3, 1 );<br />
         可能是拟合，有这一句找出的轮廓线更直。   contour里面包含了很多个轮廓，每个轮廓是单独存放的.  

输出轮廓位置！<br />
 printf(" %d elements:\n", c-&gt;total );<br />
     for( int i=0; i&lt;c-&gt;total; ++i ) {<br />
     CvPoint* p = CV_GET_SEQ_ELEM( CvPoint, c, i );<br />
        printf("    (%d,%d)\n", p-&gt;x, p-&gt;y );<br />
     }<br />
输出轮廓面积！<br />
for( ; contour; contour = contour-&gt;h_next)<br />
    {<br />
        area = fabs(cvContourArea(contour, CV_WHOLE_SEQ)); //获取当前轮廓面积<br />
        printf("area == %lf\n", area);<br />
        if(area &gt; maxArea)<br />
        {<br />
            contmax = contour;<br />
            maxArea = area;<br />
        }<br />
    }<br />
***********************************************************************************************<br />
内轮廓填充<br />
// 参数:<br />
// 1. pBinary: 输入二值图像，单通道，位深IPL_DEPTH_8U。<br />
// 2. dAreaThre: 面积阈值，当内轮廓面积小于等于dAreaThre时，进行填充。<br />
void FillInternalContours(IplImage *pBinary, double dAreaThre)<br />
{<br />
    double dConArea;<br />
    CvSeq *pContour = NULL;<br />
    CvSeq *pConInner = NULL;<br />
    CvMemStorage *pStorage = NULL;<br />
    // 执行条件<br />
    if (pBinary)<br />
    {<br />
        // 查找所有轮廓<br />
        pStorage = cvCreateMemStorage(0);<br />
        cvFindContours(pBinary, pStorage, &amp;pContour, sizeof(CvContour), CV_RETR_CCOMP, CV_CHAIN_APPROX_SIMPLE);<br />
        // 填充所有轮廓<br />
        cvDrawContours(pBinary, pContour, CV_RGB(255, 255, 255), CV_RGB(255, 255, 255), 2, CV_FILLED, 8, cvPoint(0, 0));<br />
        // 外轮廓循环<br />
        for (; pContour != NULL; pContour = pContour-&gt;h_next)<br />
        {<br />
            // 内轮廓循环<br />
            for (pConInner = pContour-&gt;v_next; pConInner != NULL; pConInner = pConInner-&gt;h_next)<br />
            {<br />
                // 内轮廓面积<br />
                dConArea = fabs(cvContourArea(pConInner, CV_WHOLE_SEQ));<br />
                if (dConArea &lt;= dAreaThre)<br />
                {<br />
                    cvDrawContours(pBinary, pConInner, CV_RGB(255, 255, 255), CV_RGB(255, 255, 255), 0, CV_FILLED, 8, cvPoint(0, 0));<br />
                }<br />
            }<br />
        }<br />
        cvReleaseMemStorage(&amp;pStorage);<br />
        pStorage = NULL;<br />
    }<br />
}  

******************************************************************* *********************<br />
// Get the contours of the connected components<br />
    std::vector&lt;std::vector&lt;cv::Point&gt;&gt; contours;<br />
    cv::findContours(image,<br />
        contours, // a vector of contours<br />
        CV_RETR_EXTERNAL, // retrieve the external contours<br />
        CV_CHAIN_APPROX_NONE); // retrieve all pixels of each contours

    // Print contours' length<br />
    std::cout &lt;&lt; "Contours: " &lt;&lt; contours.size() &lt;&lt; std::endl;<br />
    std::vector&lt;std::vector&lt;cv::Point&gt;&gt;::const_iterator itContours= contours.begin();<br />
    for ( ; itContours!=contours.end(); ++itContours)<br />
    {

        std::cout &lt;&lt; "Size: " &lt;&lt; itContours-&gt;size() &lt;&lt; std::endl;<br />
    }

***************************************************************************************<br />
// Eliminate too short or too long contours<br />
    int cmin= 100;  // minimum contour length<br />
    int cmax= 1000; // maximum contour length<br />
    std::vector&lt;std::vector&lt;cv::Point&gt;&gt;::const_iterator itc= contours.begin();<br />
    while (itc!=contours.end()) {

        if (itc-&gt;size() &lt; cmin || itc-&gt;size() &gt; cmax)<br />
            itc= contours.erase(itc);<br />
        else<br />
            ++itc;<br />
    }

输出所有轮廓的旋转角度<br />
CvBox2D     End_Rage2D;

    CvMemStorage *storage = cvCreateMemStorage(0);  //开辟内存空间

    CvSeq*      contour = NULL;     //CvSeq类型 存放检测到的图像轮廓边缘所有的像素值，坐标值特征的结构体以链表形式

    cvFindContours( pSrcImage, storage, &amp;contour, sizeof(CvContour),CV_RETR_CCOMP, CV_CHAIN_APPROX_NONE);//这函数可选参数还有不少<br />
 for(; contour; contour = contour-&gt;h_next)   //如果contour不为空，表示找到一个以上轮廓，这样写法只显示一个轮廓<br />
        //如改为for(; contour; contour = contour-&gt;h_next) 就可以同时显示多个轮廓<br />
    {  

        End_Rage2D = cvMinAreaRect2(contour);<br />
        //代入cvMinAreaRect2这个函数得到最小包围矩形  这里已得出被测物体的角度，宽度,高度，和中点坐标点存放在CvBox2D类型的结构体中，<br />
        //主要工作基本结束。

    std::cout &lt;&lt;" angle:\n"&lt;&lt;(float)End_Rage2D.angle &lt;&lt; std::endl;      //被测物体旋转角度 

    }<br />
//函数形式画轮廓<br />
void DrawRec(IplImage* pImgFrame,IplImage* pImgProcessed,int MaxArea)<br />
{<br />
    //pImgFrame:初始未处理的帧，用于最后标出检测结果的输出;<br />
    //pImgProcessed:处理完的帧,用于找运动物体的轮廓  

    stor = cvCreateMemStorage(0);  //创建动态结构和序列<br />
    cont = cvCreateSeq(CV_SEQ_ELTYPE_POINT, sizeof(CvSeq), sizeof(CvPoint) , stor);  

    // 找到所有轮廓<br />
    cvFindContours( pImgProcessed, stor, &amp;cont, sizeof(CvContour),<br />
                    CV_RETR_LIST, CV_CHAIN_APPROX_SIMPLE, cvPoint(0,0));  

    // 直接使用CONTOUR中的矩形来画轮廓<br />
    for(;cont;cont = cont-&gt;h_next)<br />
    {<br />
              CvRect r = ((CvContour*)cont)-&gt;rect;<br />
              if(r.height * r.width &gt; MaxArea) // 面积小的方形抛弃掉<br />
              {<br />
                  cvRectangle( pImgFrame, cvPoint(r.x,r.y),<br />
                          cvPoint(r.x + r.width, r.y + r.height),<br />
                          CV_RGB(255,0,0), 1, CV_AA,0);<br />
              }<br />
    }<br />
    cvShowImage("video", pImgFrame);<br />
}  

***********************************************************************************************

绍opencv 的基于面积区域过滤方法，这个对图像处理时去除小区域杂点是很有帮助的。基于区域宽度，高度等其他方式的过滤也可以根据这个方法类推。

# 图片中找到我们需要的目标 一般是最大连通区域<br />
#获取当前轮廓面积<br />
area = abs(cv.cvContourArea( contour ))<br />
# 获取最大区域矩形块<br />
aRect = cv.cvBoundingRect( contmax, 0 )<br />
#原始区域的不加边框<br />
#rcenter = cv.cvPoint2D32f(aRect.x + aRect.width/2.0, aRect.y + aRect.height/2.0)

*****************************************************************************************<br />
//移除过长或过短的轮廓<br />
    int cmin = 100; //最小轮廓长度<br />
    int cmax = 1000;    //最大轮廓<br />
    vector&lt;vector&lt;Point&gt;&gt;::const_iterator itc = contours.begin();<br />
    while (itc!=contours.end())<br />
    {<br />
        if (itc-&gt;size() &lt; cmin || itc-&gt;size() &gt; cmax)<br />
            itc = contours.erase(itc);<br />
        else<br />
            ++itc;<br />
    }  

    //在白色图像上绘制黑色轮廓<br />
    Mat result_erase(binaryImage.size(), CV_8U, Scalar(255));<br />
    drawContours(result_erase, contours,<br />
        -1, //绘制所有轮廓<br />
        Scalar(0),  //颜色为黑色<br />
        2); //轮廓线的绘制宽度为2  

 Rect r0 = boundingRect(Mat(contours[0]));<br />
    rectangle(result_erase, r0, Scalar(128), 2);<br />
    Rect r1 = boundingRect(Mat(contours[1]));<br />
    rectangle(result_erase, r1, Scalar(128), 2);  

*****************************************************************************************************************<br />
 //对前景先进行中值滤波，再进行形态学膨胀操作，以去除伪目标和连接断开的小目标<br />
 69         medianBlur(mask, mask, 5);<br />
 70         //morphologyEx(mask, mask, MORPH_DILATE, getStructuringElement(MORPH_RECT, Size(5, 5)));<br />
 71<br />
 72         //测试：先开运算再闭运算<br />
 73         morphologyEx(mask, mask, MORPH_CLOSE, getStructuringElement(MORPH_RECT, Size(5, 5)));<br />
 74         morphologyEx(mask, mask, MORPH_OPEN, getStructuringElement(MORPH_RECT, Size(5, 5)));

 //外接矩阵<br />
 93         Rect rct;<br />
 94<br />
 95         //对轮廓进行外接矩阵之前先对轮廓按面积降序排序，目的为了去除小目标（伪目标）<br />
 96         sort(contours.begin(), contours.end(), descSort);<br />
 97<br />
 98         for (int i = 0; i &lt; contours.size(); i++)<br />
 99         {<br />
100             //当第i个连通分量的外接矩阵面积小于最大面积的1/6，则认为是伪目标<br />
101             if (contourArea(contours[i]) &lt; contourArea(contours[0]) / 5)<br />
102                 break;<br />
103             //包含轮廓的最小矩阵<br />
104             rct = boundingRect(contours[i]);<br />
105             rectangle(result, rct, Scalar(0, 255, 0), 2);<br />
106<br />
107         }

**************************************************************************************************************<br />
 Mat element(5,5,CV_8U,Scalar(1));<br />
 cvMorphologyEx(green, green, NULL, element, CV_MOP_OPEN);       // 开运算,去除比结构元素小的亮点  

cvThreshold(green, green, 0.0, 255.0, CV_THRESH_BINARY | CV_THRESH_OTSU);   // OTSU法二值化  

一般用：findContours(image,contours,CV_RETR_EXTERNAL,CV_CHAIN_APPROX_NONE);<br />
int cmin=100;  

int cmax=1000;  

vector&lt;std::vector&lt;cv::Point&gt; &gt;::iterator itc = contours.begin();  

while(itc!=contours.end())  

{  

    if(itc-&gt;size()&lt;cmin||itc-&gt;size()&gt;cmax)  

        itc =contours.erase(itc);  

    else  

        itc++;  

}<br />
Mat image2=imread("E:\\group.jpg");<br />
drawContours(image2,contours,-1,Scalar(255,255,255),2);<br />
imshow("image",image2);
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7r1mj8.html">STL容器删除元素的陷阱</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx02dzq.html">GDUT&mdash;&mdash;1169&colon; Krito的讨伐（优先队列BFS）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnrloj9.html">C&sol;C&plus;&plus;获取系统时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvev0jq.html">J2SE宏观总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mgo71q.html">POJ 1195 2维线段树&lpar;树套树实现&rpar; 树状数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvjy5oq.html">手把手教你写LKM rookit&excl; 之 杀不死的pid&amp;amp&semi;root后门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0ml09.html">Xstream之常用方式与常用注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z15kvv9.html">Android版xx助手之天天酷跑外挂具体分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpp7p59.html">【BZOJ3627】【JLOI2014】路径规划 分层图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkdm3j8.html">Python远程视频监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y71gn8.html">&period;net Ajax使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zope0vq.html">JAVA&lowbar;SE基础&mdash;&mdash;11&period;Java中的运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pwl6n8.html">iOS 字体权重weight</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z4o519.html">Educational Codeforces Round 62</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2jlp0q.html">我的第一个远程代码库房：建立Github仓库 心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmxxj9.html">「NOI2015」寿司晚宴 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll0ge0q.html">Mac charles 抓取https请求，安装证书后还是显示unknown</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jxjdeq.html">python 的文件操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/953pze68.html">How to Verify Email Address</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn0xm7q.html">java数组变量</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdwrvg79.html">关于wifi网络基本原理了解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j30y3q.html">CentOS No manual entry for man  没有 xx 的手册页条目</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1lerpq.html">Java 实现将其他类型数据转换成 JSON 字符串工具类</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1d5rw9.html">process&lpar;进程&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1dwrw9.html">机器学习技法笔记：09 Decision Tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4rpme9.html">【sping揭秘】14、&commat;before  &commat;AfterThrowing</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rwge08.html">Difference Between Session&period;run and Tensor&period;eval</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zye55n9.html">python基础学习笔记 - 备忘</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gnrzmq.html">Android动态添加Fragment</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyod0mq.html">Android开发之漫漫长途 XVII&mdash;&mdash;动画&lpar;续&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
